summaryrefslogtreecommitdiffstats
path: root/scripts/updatesync.sh.in
diff options
context:
space:
mode:
authorDan McGee <dan@archlinux.org>2007-07-07 00:43:24 +0200
committerDan McGee <dan@archlinux.org>2007-07-07 00:43:24 +0200
commitb5f8a44bebc906bf6a29d30c159802b0c1a7dbb1 (patch)
treeb5096ea45a1a8b48e12dd14c446dda346c71688a /scripts/updatesync.sh.in
parent49f447d02c803e5a2f63582ce78cabb850ebfa89 (diff)
downloadpacman-b5f8a44bebc906bf6a29d30c159802b0c1a7dbb1.tar.gz
pacman-b5f8a44bebc906bf6a29d30c159802b0c1a7dbb1.tar.xz
Move scripts from *.in to *.sh.in so gettext can determine type
If we move the scripts from *.in to *.sh.in and *.py.in, gettext can pull the required strings to translate a whole lot easier. Do this. Signed-off-by: Dan McGee <dan@archlinux.org>
Diffstat (limited to 'scripts/updatesync.sh.in')
-rw-r--r--scripts/updatesync.sh.in161
1 files changed, 161 insertions, 0 deletions
diff --git a/scripts/updatesync.sh.in b/scripts/updatesync.sh.in
new file mode 100644
index 00000000..1526e285
--- /dev/null
+++ b/scripts/updatesync.sh.in
@@ -0,0 +1,161 @@
+#!/bin/bash
+#
+# updatesync
+# @configure_input@
+#
+# Copyright (c) 2004 by Jason Chu <jason@archlinux.org>
+# Derived from gensync (c) 2002-2006 Judd Vinet <jvinet@zeroflux.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
+# USA.
+#
+
+# gettext initialization
+export TEXTDOMAIN='pacman'
+export TEXTDOMAINDIR='@localedir@'
+
+myver='@PACKAGE_VERSION@'
+
+# functions
+
+usage() {
+ printf "updatesync (pacman) %s\n" "$myver"
+ echo
+ printf "$(gettext "Usage: %s <action> <destfile> <option> [package_directory]")\n" "$0"
+ echo
+ echo "$(gettext "updatesync will update a sync database by reading a PKGBUILD and")"
+ echo "$(gettext "modifying the destfile. updatesync updates the database in a temporary")"
+ echo "$(gettext "directory and then compresses it to <destfile>.")"
+ echo
+ echo "$(gettext "There are two types of actions:")"
+ echo
+ echo "$(gettext "upd - Will update a package's entry or create it if it doesn't exist.")"
+ echo "$(gettext " It takes the package's PKGBUILD as an option.")"
+ echo "$(gettext "del - Will remove a package's entry from the db.")"
+ echo "$(gettext " It takes the package's name as an option.")"
+ echo
+ echo "$(gettext "updatesync will calculate md5sums of packages in the same directory as")"
+ echo "$(gettext "<destfile>, unless an alternate [package_directory] is specified.")"
+ echo
+ echo "$(gettext "example: updatesync upd /home/mypkgs/custom.db.tar.gz PKGBUILD")"
+ echo
+ exit 0
+}
+
+version() {
+ printf "updatesync (pacman) %s\n" "$myver"
+ printf "Copyright (C) 2004 Jason Chu <jason@archlinux.org>.\n"
+ echo
+ printf "This is free software; see the source for copying conditions.\n"
+ printf "There is NO WARRANTY, to the extent permitted by law.\n"
+ echo
+}
+
+error () {
+ local mesg=$1; shift
+ printf "==> ERROR: ${mesg}\n" "$@" >&2
+}
+
+die () {
+ error $*
+ exit 1
+}
+
+check_force () {
+ local i
+ for i in ${options[@]}; do
+ local lc=$(echo $i | tr [:upper:] [:lower:])
+ if [ "$lc" = "force" ]; then
+ true
+ fi
+ done
+ false
+}
+
+# PROGRAM START
+
+if [ "$1" = "-h" -o "$1" = "--help" ]; then
+ usage
+ exit 0
+fi
+
+if [ "$1" = "-V" -o "$1" = "--version" ]; then
+ version
+ exit 0
+fi
+
+if [ $# -lt 3 ]; then
+ usage
+ exit 1
+fi
+
+# source system and user makepkg.conf
+if [ -r @sysconfdir@/makepkg.conf ]; then
+ source @sysconfdir@/makepkg.conf
+else
+ die "$(gettext "%s not found. Can not continue.")" "@sysconfdir@/makepkg.conf"
+fi
+
+if [ -r ~/.makepkg.conf ]; then
+ source ~/.makepkg.conf
+fi
+
+if [ "$1" != "upd" -a "$1" != "del" ]; then
+ usage
+ exit 1
+fi
+
+action=$1
+pkgdb=$2
+option=$3
+pkgdir="$(pwd)"
+if [ "$4" != "" ]; then
+ pkgdir="$4"
+fi
+opt_force=""
+
+if [ ! -f "$option" ]; then
+ die "$(gettext "%s not found")" $option
+fi
+
+if [ "$action" = "upd" ]; then # INSERT / UPDATE
+ unset pkgname pkgver pkgrel options
+
+ source $option || die "$(gettext "failed to parse %s")" $option
+ pkgfile="$pkgdir/$pkgname-$pkgver-$pkgrel-$CARCH.$PKGEXT"
+
+ if [ ! -f "$pkgfile" ]; then
+ die "$(gettext "could not find %s-%s-%s-%s.%s - aborting")" $pkgname $pkgver $pkgrel $CARCH $PKGEXT
+ fi
+
+ if check_force; then
+ opt_force="--force"
+ fi
+
+ repo-add "$pkgdb" $opt_force "$pkgfile"
+else # DELETE
+ fname="$(basename $option)"
+ if [ "$fname" = "PKGBUILD" ]; then
+ unset pkgname pkgver pkgrel options
+ source $option
+ else
+ pkgname=$1
+ fi
+
+ repo-remove "$pkgdb" "$pkgname"
+fi
+
+exit 0
+# vim: set ts=2 sw=2 noet: